#property copyright "Copyright 2017, TheXpert"
#property link      "https://www.trend-lab.ru"
#property strict

class ICustom
{
public:
   virtual double Value(int buffer, int index) = 0;
};

#ifdef __MQL4__

class Custom : public ICustom
{
public:
  Custom(string name, string symbol, ENUM_TIMEFRAMES tf)
    : m_name(name)
    , m_symbol(symbol)
    , m_tf(tf)
  {}
  
  string Name() const {return m_name;}
  string Instrument() const {return m_symbol;}
  ENUM_TIMEFRAMES TF() const {return m_tf;}

  virtual double Value(int buffer, int index) = 0;
  
protected:
  string m_name;
  string m_symbol;
  ENUM_TIMEFRAMES m_tf;
};

template <typename t1>
class CustomImpl1 : public Custom
{
public:
  CustomImpl1(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1)
    : Custom(name, symbol, tf)
    , m_v1(v1)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, buffer, index);
  }

private:
  t1 m_v1;
};

template <typename t1, typename t2>
class CustomImpl2 : public Custom
{
public:
  CustomImpl2(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2)
    : Custom(name, symbol, tf)
    , m_v1(v1)
    , m_v2(v2)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, m_v2, buffer, index);
  }

private:
  t1 m_v1;
  t2 m_v2;
};

template <typename t1, typename t2, typename t3>
class CustomImpl3 : public Custom
{
public:
  CustomImpl3(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3)
    : Custom(name, symbol, tf)
    , m_v1(v1)
    , m_v2(v2)
    , m_v3(v3)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, m_v2, m_v3, buffer, index);
  }

private:
  t1 m_v1;
  t2 m_v2;
  t3 m_v3;
};

template <typename t1, typename t2, typename t3, typename t4>
class CustomImpl4 : public Custom
{
public:
  CustomImpl4(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4)
    : Custom(name, symbol, tf)
    , m_v1(v1)
    , m_v2(v2)
    , m_v3(v3)
    , m_v4(v4)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, m_v2, m_v3, m_v4, buffer, index);
  }

private:
  t1 m_v1;
  t2 m_v2;
  t3 m_v3;
  t4 m_v4;
};

template <typename t1, typename t2, typename t3, typename t4, typename t5>
class CustomImpl5 : public Custom
{
public:
  CustomImpl5(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5)
    : Custom(name, symbol, tf)
    , m_v1(v1)
    , m_v2(v2)
    , m_v3(v3)
    , m_v4(v4)
    , m_v5(v5)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, m_v2, m_v3, m_v4, m_v5, buffer, index);
  }

private:
  t1 m_v1;
  t2 m_v2;
  t3 m_v3;
  t4 m_v4;
  t5 m_v5;
};

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6>
class CustomImpl6 : public Custom
{
public:
  CustomImpl6(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6)
    : Custom(name, symbol, tf)
    , m_v1(v1)
    , m_v2(v2)
    , m_v3(v3)
    , m_v4(v4)
    , m_v5(v5)
    , m_v6(v6)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, m_v2, m_v3, m_v4, m_v5, m_v6, buffer, index);
  }

private:
  t1 m_v1;
  t2 m_v2;
  t3 m_v3;
  t4 m_v4;
  t5 m_v5;
  t6 m_v6;
};

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7>
class CustomImpl7 : public Custom
{
public:
  CustomImpl7(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7)
    : Custom(name, symbol, tf)
    , m_v1(v1)
    , m_v2(v2)
    , m_v3(v3)
    , m_v4(v4)
    , m_v5(v5)
    , m_v6(v6)
    , m_v7(v7)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, m_v2, m_v3, m_v4, m_v5, m_v6, m_v7, buffer, index);
  }

private:
  t1 m_v1;
  t2 m_v2;
  t3 m_v3;
  t4 m_v4;
  t5 m_v5;
  t6 m_v6;
  t7 m_v7;
};

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7, typename t8>
class CustomImpl8 : public Custom
{
public:
  CustomImpl8(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7, t8 v8)
    : Custom(name, symbol, tf)
    , m_v1(v1)
    , m_v2(v2)
    , m_v3(v3)
    , m_v4(v4)
    , m_v5(v5)
    , m_v6(v6)
    , m_v7(v7)
    , m_v8(v8)
  {}
  
  double Value(int buffer, int index)
  {
    return iCustom(m_symbol, m_tf, m_name, m_v1, m_v2, m_v3, m_v4, m_v5, m_v6, m_v7, m_v8, buffer, index);
  }

private:
  t1 m_v1;
  t2 m_v2;
  t3 m_v3;
  t4 m_v4;
  t5 m_v5;
  t6 m_v6;
  t7 m_v7;
  t8 m_v8;
};

template <typename t1>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1)
{return new CustomImpl1<t1>(name, symbol, tf, v1);}
template <typename t1>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1)
{return new CustomImpl1<t1>(name, symbol, (ENUM_TIMEFRAMES)tf, v1);}

template <typename t1, typename t2>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2)
{return new CustomImpl2<t1, t2>(name, symbol, tf, v1, v2);}
template <typename t1, typename t2>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1, t2 v2)
{return new CustomImpl2<t1, t2>(name, symbol, (ENUM_TIMEFRAMES)tf, v1, v2);}

template <typename t1, typename t2, typename t3>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3)
{return new CustomImpl3<t1, t2, t3>(name, symbol, tf, v1, v2, v3);}
template <typename t1, typename t2, typename t3>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1, t2 v2, t3 v3)
{return new CustomImpl3<t1, t2, t3>(name, symbol, (ENUM_TIMEFRAMES)tf, v1, v2, v3);}

template <typename t1, typename t2, typename t3, typename t4>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4)
{return new CustomImpl4<t1, t2, t3, t4>(name, symbol, tf, v1, v2, v3, v4);}
template <typename t1, typename t2, typename t3, typename t4>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1, t2 v2, t3 v3, t4 v4)
{return new CustomImpl4<t1, t2, t3, t4>(name, symbol, (ENUM_TIMEFRAMES)tf, v1, v2, v3, v4);}

template <typename t1, typename t2, typename t3, typename t4, typename t5>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5)
{return new CustomImpl5<t1, t2, t3, t4, t5>(name, symbol, tf, v1, v2, v3, v4, v5);}
template <typename t1, typename t2, typename t3, typename t4, typename t5>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5)
{return new CustomImpl5<t1, t2, t3, t4, t5>(name, symbol, (ENUM_TIMEFRAMES)tf, v1, v2, v3, v4, v5);}

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6)
{return new CustomImpl6<t1, t2, t3, t4, t5, t6>(name, symbol, tf, v1, v2, v3, v4, v5, v6);}
template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6)
{return new CustomImpl6<t1, t2, t3, t4, t5, t6>(name, symbol, (ENUM_TIMEFRAMES)tf, v1, v2, v3, v4, v5, v6);}

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7)
{return new CustomImpl7<t1, t2, t3, t4, t5, t6, t7>(name, symbol, tf, v1, v2, v3, v4, v5, v6, v7);}
template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7)
{return new CustomImpl7<t1, t2, t3, t4, t5, t6, t7>(name, symbol, (ENUM_TIMEFRAMES)tf, v1, v2, v3, v4, v5, v6, v7);}

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7, typename t8>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7, t8 v8)
{return new CustomImpl8<t1, t2, t3, t4, t5, t6, t7, t8>(name, symbol, tf, v1, v2, v3, v4, v5, v6, v7, v8);}
template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7, typename t8>
ICustom* CreateCustom(string name, string symbol, int tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7, t8 v8)
{return new CustomImpl8<t1, t2, t3, t4, t5, t6, t7, t8>(name, symbol, (ENUM_TIMEFRAMES)tf, v1, v2, v3, v4, v5, v6, v7, v8);}

#endif // __MQL4__

// =======================================================

#ifdef __MQL5__

class Custom : public ICustom
{
public:
  Custom(int handle)
    : m_handle(handle)
  {}
  
  ~Custom()
  {
     IndicatorRelease(m_handle);
  }
  
  double Value(int buffer, int index)
  {
    double result[];
    int copied = CopyBuffer(m_handle, buffer, index, 1, result);
    return copied > 0 ? result[0] : EMPTY_VALUE;
  }

protected:
  int m_handle;   
};

ICustom* CreateCustom(int handle)
{
   if (handle == INVALID_HANDLE)
   {
      Alert("custom indicator creation failed, error #", GetLastError());
   }
   return new Custom(handle);
}

template <typename t1>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1)
{return CreateCustom(iCustom(symbol, tf, name, v1));}

template <typename t1, typename t2>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2)
{return CreateCustom(iCustom(symbol, tf, name, v1, v2));}

template <typename t1, typename t2, typename t3>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3)
{return CreateCustom(iCustom(symbol, tf, name, v1, v2, v3));}

template <typename t1, typename t2, typename t3, typename t4>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4)
{return CreateCustom(iCustom(symbol, tf, name, v1, v2, v3, v4));}

template <typename t1, typename t2, typename t3, typename t4, typename t5>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5)
{return CreateCustom(iCustom(symbol, tf, name, v1, v2, v3, v4, v5));}

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6)
{return CreateCustom(iCustom(symbol, tf, name, v1, v2, v3, v4, v5, v6));}

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7)
{return CreateCustom(iCustom(symbol, tf, name, v1, v2, v3, v4, v5, v6, v7));}

template <typename t1, typename t2, typename t3, typename t4, typename t5, typename t6, typename t7, typename t8>
ICustom* CreateCustom(string name, string symbol, ENUM_TIMEFRAMES tf, t1 v1, t2 v2, t3 v3, t4 v4, t5 v5, t6 v6, t7 v7, t8 v8)
{return CreateCustom(iCustom(symbol, tf, name, v1, v2, v3, v4, v5, v6, v7, v8));}

#endif // __MQL5__